=== debian/changelog ===
ros-humble-fastrtps (2.6.6-1jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Miguel Company <miguelcompany@eprosima.com>  Mon, 07 Aug 2023 05:47:08 -0000
