=== debian/control ===
Source: ros-humble-fastrtps
Section: misc
Priority: optional
Maintainer: Miguel Company <miguelcompany@eprosima.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libasio-dev, libssl-dev, libtinyxml2-dev, python3-dev, ros-humble-fastcdr, ros-humble-foonathan-memory-vendor, ros-humble-ros-workspace
Homepage: https://www.eprosima.com/
Standards-Version: 3.9.2

Package: ros-humble-fastrtps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libssl-dev, libtinyxml2-dev, python3-dev, ros-humble-fastcdr, ros-humble-foonathan-memory-vendor, ros-humble-ros-workspace
Description: *eprosima Fast DDS* (formerly Fast RTPS) is a C++ implementation of the DDS (Data Distribution Service) standard of the OMG (Object Management Group).
 eProsima Fast DDS implements the RTPS (Real Time Publish Subscribe) protocol, which provides publisher-subscriber communications over unreliable transports such as UDP, as defined and maintained by the Object Management Group (OMG) consortium. RTPS is also the wire interoperability protocol defined for the Data Distribution Service (DDS) standard. *eProsima Fast DDS* expose an API to access directly the RTPS protocol, giving the user full access to the protocol internals.
